//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that a reference to the base part of the current (derived)
// object can be passed to a method of the base class.

class base {
public:
	int data_member;
	void method (base&);
};

class derived : public base {
public:
	derived()
	{
		base& prev = *this;

		method (prev);
	}
};

int main ()
{
	derived derived_object;
	derived_object.data_member = 0;
	return 0;
}

void base::method (base&)
{
	return;
}
