//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that an overloading of the arrow (->) operator works.
//
// This test is derived from the 1987 USENIX C++ workshop proceedings.

struct s1
{ 
	int s1_member;
};

class base 
{
	s1* ptr;
public:
	s1* operator->();
	base();
};

int main () 
{
	base base_object;

	base_object->s1_member = 5;
	return 0;
};

s1* base::operator->() 
{
	if (ptr == 0)
		ptr = new s1;
	return ptr;
};

base::base ()
{
	ptr = 0;
}
