//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that default arguments may be non constant expressions.

int global_variable;
const int global_const = 99;

int func1 (int i);
int func2 (int j);

int function (int k = func2 (func1 (global_variable + global_const)));

class base {
	int field;
public:
	base () {}
	int function (int k = func2 (func1 (global_variable + global_const)));
};

int j;

int main ()
{
	base b;

	global_variable = 99;
	function ();
	b.function ();
	return 0;
}

int function (int k)
{
	j = k;
	return 0;
}

int base::function (int k)
{
	j = k;
	return 0;
}

int func1 (int i)
{
	return 1+i;
}

int func2 (int j)
{
	return 2+j;
}
