//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that it is illegal to declare member unary
// operators with more than zero explicit formal arguments.
//
// Note that operators which are members may not be static
// (with the exception of operators new & delete).

typedef unsigned long size_t;

struct st {
	int member;
};

struct base {
	int member;

	// Unary + could be binary
	//int operator + (st b);

	// unary - could be binary
	//int operator - (st b);

	// unary & could be binary
	//int operator & (st b);

	// unary * could be binary
	//int operator * (st b);

	int operator ~ (st b);			// ERROR

	int operator ! (st b);			// ERROR

	int operator ++ (st b);			// ERROR

	int operator -- (st b);			// ERROR

	st* operator -> (st b);			// ERROR

	void* operator new (size_t b);		// OK - implicitly static

	void operator delete (void* b);		// OK - implicitly static

	operator int (st b);			// ERROR

	operator st (st b);			// ERROR

	operator base (st b);			// ERROR
};
