//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that if an operator returns a reference type, that
// the return value may not be assigned to a pointer variable
// of the same base type.

struct base1 {
	int member;
};

struct base2 {
	int member;

	base1& operator [] (int index);
};

base1 base1_object;
base2 base2_object;

base1* base_pointer;

int main ()
{
	base_pointer = base2_object[37];	// ERROR
	return 0;
}

base1& base2::operator [] (int index)
{
	index = index;				// avoid warnings
	return base1_object;
}
