//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that it is illegal to declare a member function which
// returns a type which has not yet been fully declared.
//
// This code causes G++ 1.35.0 to abort.
//
// Cases:
//	undeclared type
//	incompletely declared type

struct base1 {
	int data_member;

	struct undefined member () {		// ERROR
		return *(struct undefined *)0;
	}
};

struct incomplete;

struct base2 {
	int data_member;

	struct incomplete member () {		// ERROR
		return *(struct incomplete *)0;
	}
};
