//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that if a function is declared as "virtual" (but not static)
// in a given base class that it may not be declared to be static in
//  a class derived from the given base class.
//
// This causes G++ 1.35.0 to segfault.

struct base
{
    virtual void member();
};

struct derived : public base
{
    static void member();		// ERROR
};

class derived *derived_ptr;

void test ()
{
    derived_ptr->member();		// Possible error
}
