//  This file is part of GNU c++-suite.
//  
//  GNU c++-suite is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//  
//  GNU c++-suite is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with GNU c++-suite; see the file COPYING.  If not, write to
//  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

// Check that it is illegal for a member function definition
// or declaration to preceed the definition of the class type
// of which it is a member.
//
// Cases:
//	function declarations
//	function definitions
//
// Cases:
//	no preceeding class declaration
//	incomplete preceeding class declaration

void later::function_member_1 ();		// ERROR

void later::function_member_2 () {		// ERROR
}

struct later {
	int data_member;

	void function_member_1 () { }
	void function_member_2 ();
};

struct incomplete;

void incomplete::function_member_1 ();		// ERROR

void incomplete::function_member_2 () {		// ERROR
}

struct incomplete {
	int data_member;

	void function_member_1 () { }
	void function_member_2 ();
};
